/* $NetBSD$ */

#include <sys/types.h>

#include <stdio.h>

#include "input.h"
#include "pulse_on.h"
#include "pulse_off.h"

int
main(void)
{
	int i;

	printf("/* $NetBSD$ */\n");
	printf("static const unsigned _splash_width = %d;\n", width);
	printf("static const unsigned _splash_height = %d;\n", height);
	printf("static const unsigned _pulse_on_width = %d;\n", _pulse_on_width);
	printf("static const unsigned _pulse_on_height = %d;\n", _pulse_on_height);
	printf("static const unsigned _pulse_off_width = %d;\n", _pulse_off_width);
	printf("static const unsigned _pulse_off_height = %d;\n", _pulse_off_height);
	printf("#define _SPLASH_HEADER_PIXEL(_d,_p) { \\\n");
	printf(" _p[0] = _splash_header_data_cmap[(unsigned char)_d[0]][0]; \\\n");
	printf(" _p[1] = _splash_header_data_cmap[(unsigned char)_d[0]][1]; \\\n");
	printf(" _p[2] = _splash_header_data_cmap[(unsigned char)_d[0]][2]; \\\n");
	printf(" _d++; }\n");
	printf("#define _PULSE_OFF_HEADER_PIXEL(_d,_p) { \\\n");
	printf(" _p[0] = _splash_header_data_cmap[(unsigned char)_d[0] + 64][0]; \\\n");
	printf(" _p[1] = _splash_header_data_cmap[(unsigned char)_d[0] + 64][1]; \\\n");
	printf(" _p[2] = _splash_header_data_cmap[(unsigned char)_d[0] + 64][2]; \\\n");
	printf(" _d++; }\n");
	printf("#define _PULSE_ON_HEADER_PIXEL(_d,_p) { \\\n");
	printf(" _p[0] = _splash_header_data_cmap[(unsigned char)_d[0] + 64 + 16][0]; \\\n");
	printf(" _p[1] = _splash_header_data_cmap[(unsigned char)_d[0] + 64 + 16][1]; \\\n");
	printf(" _p[2] = _splash_header_data_cmap[(unsigned char)_d[0] + 64 + 16][2]; \\\n");
	printf(" _d++; }\n");


	printf("const char _splash_header_data_cmap[64+32][3] = {\n");
	for (i = 0; i < 64; i++) {
		printf("  { %u, %u, %u },\n",
		    (uint8_t)header_data_cmap[i][0],
		    (uint8_t)header_data_cmap[i][1],
		    (uint8_t)header_data_cmap[i][2]);
	}
	for (i = 0; i < 16; i++) {
		printf("  { %u, %u, %u },\n",
		    (uint8_t)_pulse_off_header_data_cmap[i][0],
		    (uint8_t)_pulse_off_header_data_cmap[i][1],
		    (uint8_t)_pulse_off_header_data_cmap[i][2]);
	}
	for (i = 0; i < 16; i++) {
		printf("  { %u, %u, %u },\n",
		    (uint8_t)_pulse_on_header_data_cmap[i][0],
		    (uint8_t)_pulse_on_header_data_cmap[i][1],
		    (uint8_t)_pulse_on_header_data_cmap[i][2]);
	}
		
	printf("};\n");
	printf("static const char _splash_header_data[] = {\n");
	for (i = 0; i < (width * height); i++) {
		printf(" %u,", (uint8_t)header_data[i]);
		if (i > 0 && (i % 10 == 0))
			printf("\n");
		else if (i == ((width * height) - 1))
			printf("\n");
	}
	printf("};\n");

	printf("static const char _pulse_off_header_data[] = {\n");
	for (i = 0; i < (_pulse_off_width * _pulse_off_height); i++) {
		printf(" %u,", (uint8_t)_pulse_off_header_data[i] + 64);
		if (i > 0 && (i % 10 == 0))
			printf("\n");
		else if (i == ((_pulse_off_width * _pulse_off_height) - 1))
			printf("\n");
	}
	printf("};\n");

	printf("static const char _pulse_on_header_data[] = {\n");
	for (i = 0; i < (_pulse_on_width * _pulse_on_height); i++) {
		printf(" %u,", (uint8_t)_pulse_on_header_data[i] + 64 + 16);
		if (i > 0 && (i % 10 == 0))
			printf("\n");
		else if (i == ((_pulse_on_width * _pulse_on_height) - 1))
			printf("\n");
	}
	printf("};\n");
}
